



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>mysql 开发进阶篇系列 17 MySQL Server(key_buffer与table_cache)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">mysql 开发进阶篇系列 17 MySQL Server(key_buffer与table_cache)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-15 06:30:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>一.key_buffer</h3>
<p>　　上一篇了解key_buffer设置，key_buffer_size指定了索引缓冲区的大小，它决定索引处理的速度，尤其是索引读的速度。通过检查状态值Key_read_requests和Key_reads，可以知道key_buffer_size设置是否合理。比例key_reads /key_read_requests应该尽可能的低，至少是1:100，1:1000更好(理解为key_reads物理IO次数越少越好)。</p>
<div>
<pre class="prettyprint linenums">--   一共有Key_read_requests个索引请求，一共发生了Key_reads次物理IO<br />
SHOW GLOBAL STATUS LIKE '%key_read%';</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/151560/201808/151560-20180807174845268-1681482280.png" /></p>
<div>
<pre class="prettyprint linenums">--  Key_reads/Key_read_requests &asymp; 0.1%以下比较好<br />
SELECT 693206.0/94745304.0</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/151560/201808/151560-20180807174907125-2062729675.png" /></p>
<p>　　key_buffer_size只对MyISAM表起作用。即使你不使用MyISAM表，但是内部的临时磁盘表是MyISAM表，也要使用该值，可以使用检查状态值created_tmp_disk_tables得知详情。</p>
<div>
<pre class="prettyprint linenums">SHOW GLOBAL STATUS LIKE '%created_tmp_disk_tables%';</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/151560/201808/151560-20180807175110246-725802930.png" /></p>
<p>总结建议：</p>
<p>　　　　对于1G内存的机器，如果不使用MyISAM表，推荐值是16M（8-64M）。<br />　　　　单个key_buffer的大小不能超过4G。<br />　　　　建议key_buffer设置为物理内存的1/4(针对MyISAM引擎)，在很多情况下数据要比索引大得多。<br />　　　　如果机器性能优越，可以设置多个key_buffer,分别让不同的key_buffer来缓存专门的索引。<br />　　　　Key_reads/Key_read_requests的大小正常情况下得小于0.01。</p>
<h3>二.&nbsp;table_cache&nbsp;(table_open_cache)　　</h3>
<p>　　上面讲了索引缓存，这里讲表缓存 table_cache,在mysql 5.1之后叫做"table_open_cache"。这个参数表示数据库用户打开表的缓存数量(最大限制数)，用于设置table高速缓存的数量。由于每个客户端连接都会至少访问一个表，因此此参数的值与max_connections有关。例如 对于200个并行运行的连接，应该让表的缓存至少有200 * N。这里N是可以执行的查询的一个连接中表的最大数量（表数量）。<br />　　表缓存机制是：当某一连接访问一个表时，MySQL会检查当前已缓存表的数量。如果该表已经在缓存中打开，则会直接访问缓存中的表已加快查询速度；如果该表未被缓存，则会将当前的表添加进缓存并进行查询。<br />　　在执行缓存操作之前，table_cache用于限制缓存表的最大数目：如果当前已经缓存的表未达到table_cache，则会将新表添加进来；若已经达到此值，MySQL将根据缓存表的最后查询时间、查询率等规则释放之前的缓存(释放机制与sqlserver一样)。</p>
<div>
<pre class="prettyprint linenums">-- 表缓存限制数(默认是2000次)<br />
SHOW VARIABLES LIKE 'table_open_cache';    </pre>
</div>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/151560/201808/151560-20180808134430797-1416165958.png" /></p>
<div>
<pre class="prettyprint linenums">-- 最大并发连接数<br />
SHOW VARIABLES LIKE 'max_connections';</pre>
</div>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/151560/201808/151560-20180808135527787-218370307.png" /></p>
<p>　　可以通过检查mysqld的状态变量open_tables和opened_tables确定table_cache参数是否过小。 open_tables表示<strong>当前打开的表缓存数</strong>，如果执行flush tables操作，则系统会关闭一些当前没有使用的表缓存,而使得些状态值减小。opened_tables表示曾经打开的表缓存数(<strong>历史的</strong>)，会一直进行累加。执行flush tables值不会减少。</p>
<div>
<pre class="prettyprint linenums">-- 当前打开的表缓存数<br />
SHOW  GLOBAL STATUS LIKE 'open_tables';</pre>
</div>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/151560/201808/151560-20180808134516195-1378192572.png" /></p>
<div>
<pre class="prettyprint linenums">-- 曾经打开的表缓存数<br />
SHOW  GLOBAL STATUS LIKE 'opened_tables';</pre>
</div>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/151560/201808/151560-20180808134550462-592273181.png" /><br />　　2.1演示下open_tables和opened_tables值的变化(在另一台mysql上进行)</p>
<p>　　第一步：</p>
<div>
<pre class="prettyprint linenums">-- 清空表缓存<br />
FLUSH TABLES;<br />
-- 查看值为1(代表当前连接)<br />
SHOW  GLOBAL STATUS LIKE 'open_tables';</pre>
</div>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/151560/201808/151560-20180808134723059-375674907.png" /></p>
<div>
<pre class="prettyprint linenums">-- 历史值为111<br />
SHOW  GLOBAL STATUS LIKE 'opened_tables';</pre>
</div>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/151560/201808/151560-20180808134749625-1139109157.png" /><br />　　第二步：</p>
<div>
<pre class="prettyprint linenums">-- 执行一个查询<br />
SELECT COUNT(1) FROM User1<br />
-- 再次查询当前缓存数<br />
SHOW  GLOBAL STATUS LIKE 'open_tables';</pre>
</div>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/151560/201808/151560-20180808134849465-1183444676.png" /></p>
<div>
<pre class="prettyprint linenums">--历史值也累加到113<br />
SHOW  GLOBAL STATUS LIKE 'opened_tables';</pre>
</div>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/151560/201808/151560-20180808134920996-923807981.png" /><br />　　第三步：</p>
<div>
<pre class="prettyprint linenums">-- 再执行一个相同查询,  会发现值没有增加，因为读的是缓存。<br />
SELECT COUNT(1) FROM User1<br />
SHOW  GLOBAL STATUS LIKE 'open_tables';</pre>
</div>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/151560/201808/151560-20180808135005491-1854634866.png" /></p>
<div>
<pre class="prettyprint linenums">SHOW  GLOBAL STATUS LIKE 'opened_tables';</pre>
</div>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/151560/201808/151560-20180808135027350-374173380.png" /></p>
<h3>三. 修改table_cache值　　　　　　</h3>
<p>　　下面来尝试修改table_cache值， 还是一样找到my.cnf<br />	　　[root@xuegod64 etc]# vim my.cnf<br />　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/151560/201808/151560-20180808135206354-92266270.png" /></p>
<p>　　[root@xuegod64 ~]# systemctl stop mysqld.service<br />　　[root@xuegod64 ~]# /bin/systemctl start mysqld.service</p>
<div>
<pre class="prettyprint linenums">-- 服务停止重启后再次查看表缓存限制数。<br />
SHOW VARIABLES LIKE 'table_open_cache';</pre>
</div>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/151560/201808/151560-20180808135303727-284649159.png" /></p>
<h3>四.table_cache总结</h3>
<p>　　open_tables是当前表缓存数，类似于sql server的逻辑查询而非物理查询。 该open_tables的值对设置table_cache值有重要的参考价值。<br />    　　如果Open_tables的值已经接近table_cache的值，且Opened_tables还在不断变大，则说明mysql正在将缓存的表释放以容纳新的表，此时可能需要加大table_cache的值。下面这台mysql服务器正是这种情况，1990接近最大限制2000,且历史值还在不断变大。 如下图:<br />　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/151560/201808/151560-20180808135627848-177896709.png" /></p>
<p>　　比较适合的值建议：</p>
<p>　　Open_tables / Opened_tables &gt;= 0.85</p>
<p>　　当前mysql的值：SELECT 1990.0/3286078.0=0.00061</p>
<p>　　Open_tables / table_cache &lt;= 0.95</p>
<p>　　当前mysql的值：1990.0/2000.0=0.99500</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qx42ed9.html">3、软件评测师要阅读的书籍 - IT软件人员书籍系列文章</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8owr5p9.html">MapReduce 程序运行报错  java&period;lang&period;ClassNotFoundException解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96nweyq.html">ruby on rails on windows</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jo634q.html">Oracle 建表，递增序列，触发器，分析函数row&lowbar;number&lpar;&rpar; &comma;partition by 子句。</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zz0pd8.html">安装python 的 包 paramiko</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rjgme8.html">MUI - 预加载</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zzmwz9.html">&lbrack;HDOJ4609&rsqb;3-idiots（FFT，计数）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmmd419.html">python中列表的操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ywej5q.html">转：maven报错非法字符：&bsol;65279 错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpjdmxq.html">ipv4属性无法打开</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meo10rq.html">STS4 add spring bean configuration file</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jg6n5q.html">C&plus;&plus;函数指针与指针函数干货</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2rely9.html">01 bubbleSort</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll3jg1q.html">UVA 11796 Dog Distance&lpar;几何&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r7wjz8.html">springboot----&amp;gt&semi;java&period;lang&period;IllegalArgumentException</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw4zpy8.html">zabbix3&period;4&period;7表结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4pomm9.html">【杂谈】Java I&sol;O的底层实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q257ggoq.html">当DataTable的列名遇上特殊字符&amp;quot&semi;&lbrack;&amp;quot&semi;和&amp;quot&semi;&rsqb;&amp;quot&semi;时</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlld5r9.html">Docker 入门（Mac环境）-part 1  入门基本操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/953jgom8.html">spring boot 学习番外篇：超快速项目初始化</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9r5goe7q.html">关于下载calipso数据集以及用python将其读到记事本小结</a>
			</li>
						<li><a href="https://www.batexi.com/a/q255d63q.html">php final</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o11j5pq.html">Linux关于文件&comma;文件夹操作命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/96003yv9.html">java性能分析工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e44m3k9.html">IOS 模拟器多开集成测试和那些坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvvn028.html">maven配置parent pom查找策略</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7oo7gg8.html">Linux shell脚本学习（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wwjkrq.html">prototype 和 &lowbar;&lowbar;proto&lowbar;&lowbar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvv50l8.html">多级路由请求js文件路径不对的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rrezo9.html">通过脚本下载GO被墙或常用的相关包</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
